<template>
  <div>
    <td
      :style="backgroundColor"
      class="line-number-cell"
    >
      <v-btn
        text
        block
        depressed
        class="line-number-btn"
        @click="toggleEditor"
      >
        {{ lineNo }}
      </v-btn>
    </td>
    <td class="code-cell-content pl-2">
      <!-- eslint-disable-next-line -->
      <span
        :key="key"
        class="code-line"
        v-html="html"
      />
      <slot />
    </td>
  </div>
</template>

<script>
import { subNotesEventBus } from '../../../store/modules/submission-notes'
export default {
  name: 'SubmissionLine',
  props: {
    lineNo: {
      type: String,
      required: true
    },
    code: {
      type: String,
      required: true
    },
    codeLanguage: {
      type: String,
      default: 'lang-c'
    },
    hint: {
      type: Boolean,
      default: false,
    },
  },
  data () {
    return {
      key: 0,
      html:''
    }
  },
  computed: {
    backgroundColor() {
      return this.hint ? 'background-color: #F44336;' : 'background-color: transparent;'
    }
  },
  created () {
    subNotesEventBus.$on('resetSubmission', () => {
      this.key++
    })
    const {marked} = require('marked')
    this.html = marked.parse(this.code)
  },
  methods: {
    toggleEditor () {
      this.$emit('toggleEditor')
    }
  }
}
</script>

<style scoped>
  .line-number-cell {
    vertical-align: top;
  }

  .code-cell-content {
    width: 100%;
  }

  .code-line {
    white-space: normal;
    font-family: monospace;
  }

  .line-number-btn {
    height: fit-content;
    min-width: 50px;
    margin: 0;
    border-radius: 0;
  }
</style>
